-- The default rotations generator for ROGUES.
local rogueRotationsGenerator = function ()
	local rotation = {
		["defaultRotation/rogue/assassination"] = {
			["bindindex"] = 0,
			["SortedActions"] = {
				"defaultRotation/rogue/kick", -- [1]
				"defaultRotation/rogue/agonizing_poison", -- [2]
				"defaultRotation/rogue/deadly_poison", -- [3]
				"defaultRotation/rogue/leeching_poison", -- [4]
				"defaultRotation/rogue/crimson_vial", -- [5]
				"defaultRotation/rogue/marked_for_death_anticipation", -- [6]
				"defaultRotation/rogue/marked_for_death_deeper_stratagem", -- [7]
				"defaultRotation/rogue/marked_for_death", -- [8]
				"defaultRotation/rogue/rupture_deeper_stratagem", -- [9]
				"defaultRotation/rogue/rupture", -- [10]
				"defaultRotation/rogue/death_from_above_deeper_stratagem", -- [11]
				"defaultRotation/rogue/death_from_above", -- [12]
				"defaultRotation/rogue/envenom_deeper_stratagem", -- [13]
				"defaultRotation/rogue/envenom", -- [14]
				"defaultRotation/rogue/garrote", -- [15]
				"defaultRotation/rogue/garrote_deeper_stratagem", -- [16]
				"defaultRotation/rogue/vendetta", -- [17]
				"defaultRotation/rogue/exsanguinate", -- [18]
				"defaultRotation/rogue/hemorrhage", -- [19]
				"defaultRotation/rogue/kingsbane", -- [20]
				"defaultRotation/rogue/mutilate_deeper_stratagem", -- [21]
				"defaultRotation/rogue/mutilate", -- [22]
			},
			["ActionList"] = {
				["defaultRotation/rogue/death_from_above"] = {
					["b_gspellcost"] = true,
					["b_p_knownotspell"] = true,
					["v_durationstartedtime"] = 0,
					["v_keybind"] = "<keybind>",
					["v_gspellcost"] = "25",
					["v_p_knownotspell"] = "193531",
					["b_p_unitpower"] = true,
					["v_togglename"] = "Toggle 1",
					["v_p_unitpowertype"] = "4",
					["v_spellname"] = "152150",
					["v_gspellcosttype"] = "3",
					["v_checkothercdvalue"] = "<1.5",
					["v_p_unitpower"] = ">=4",
					["v_checkothercdname"] = "152150",
				},
				["defaultRotation/rogue/mutilate"] = {
					["b_gspellcost"] = true,
					["v_p_unitpowertype"] = "4",
					["v_gunitpowertype"] = "4",
					["v_p_unitpower"] = "<4",
					["v_keybind"] = "<keybind>",
					["v_gspellcost"] = "55",
					["v_durationstartedtime"] = 0,
					["v_p_knownotspell"] = "193531",
					["b_gunitpower"] = true,
					["v_spellname"] = "1329",
					["v_gspellcosttype"] = "3",
					["b_p_knownotspell"] = true,
					["v_gunitpower"] = "2",
					["v_togglename"] = "Toggle 1",
				},
				["defaultRotation/rogue/envenom_deeper_stratagem"] = {
					["b_gspellcost"] = true,
					["v_p_knowspell"] = "193531",
					["b_p_unitpower"] = true,
					["v_gspellcosttype"] = "3",
					["b_p_knowspell"] = true,
					["v_togglename"] = "Toggle 1",
					["v_p_unitpowertype"] = "4",
					["v_spellname"] = "32645",
					["v_gspellcost"] = "35",
					["v_keybind"] = "<keybind>",
					["v_p_unitpower"] = ">=5",
					["v_durationstartedtime"] = 0,
				},
				["defaultRotation/rogue/leeching_poison"] = {
					["v_p_needbuff"] = "108211",
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "108211",
					["b_p_needbuff"] = true,
					["v_keybind"] = "<keybind>",
				},
				["defaultRotation/rogue/crimson_vial"] = {
					["v_keybind"] = "<keybind>",
					["v_p_hp"] = "<60%",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "185311",
					["v_togglename"] = "Toggle 1",
					["v_checkothercdvalue"] = "<1.5",
					["b_p_hp"] = true,
					["v_checkothercdname"] = "185311",
				},
				["defaultRotation/rogue/kick"] = {
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "1766",
					["v_keybind"] = "<keybind>",
					["v_checkothercdvalue"] = "<1.5",
					["b_t_interrupt"] = true,
					["v_checkothercdname"] = "1766",
				},
				["defaultRotation/rogue/garrote"] = {
					["v_t_needsdebuff"] = "_703^5.4",
					["v_gunitpowertype"] = "4",
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "703",
					["v_gspellcosttype"] = "3",
					["v_checkothercdvalue"] = "<1.5",
					["v_gunitpower"] = "1",
					["v_checkothercdname"] = "703",
					["b_gspellcost"] = true,
					["b_p_unitpower"] = true,
					["b_gunitpower"] = true,
					["v_p_unitpowertype"] = "4",
					["b_t_needsdebuff"] = true,
					["v_keybind"] = "<keybind>",
					["v_p_unitpower"] = "<5",
					["v_gspellcost"] = "45",
				},
				["defaultRotation/rogue/mutilate_deeper_stratagem"] = {
					["b_gspellcost"] = true,
					["v_p_unitpower"] = "<5",
					["v_p_knowspell"] = "193531",
					["v_p_unitpowertype"] = "4",
					["v_gspellcosttype"] = "3",
					["v_durationstartedtime"] = 0,
					["b_p_knowspell"] = true,
					["v_togglename"] = "Toggle 1",
					["b_gunitpower"] = true,
					["v_spellname"] = "1329",
					["v_gspellcost"] = "55",
					["v_keybind"] = "<keybind>",
					["v_gunitpower"] = "2",
					["v_gunitpowertype"] = "4",
				},
				["defaultRotation/rogue/envenom"] = {
					["b_gspellcost"] = true,
					["v_p_unitpowertype"] = "4",
					["v_p_knownotspell"] = "193531",
					["v_keybind"] = "<keybind>",
					["v_gspellcosttype"] = "3",
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "32645",
					["v_gspellcost"] = "35",
					["b_p_knownotspell"] = true,
					["v_p_unitpower"] = ">=4",
					["b_p_unitpower"] = true,
				},
				["defaultRotation/rogue/marked_for_death"] = {
					["v_togglename"] = "Toggle 1",
					["v_p_unitpower"] = "<1",
					["v_t_needsbuff"] = "_137619",
					["b_p_knownotspell"] = true,
					["v_gunitpowertype"] = "4",
					["v_keybind"] = "<keybind>",
					["b_t_needsbuff"] = true,
					["v_p_unitpowertype"] = "4",
					["b_gunitpower"] = true,
					["v_p_knownotspell"] = "114015||193531",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "137619",
					["b_p_unitpower"] = true,
					["v_checkothercdvalue"] = "<1.5",
					["v_gunitpower"] = "5",
					["v_checkothercdname"] = "137619",
				},
				["defaultRotation/rogue/rupture_deeper_stratagem"] = {
					["v_t_needsdebuff"] = "_1943^8.4",
					["v_p_unitpowertype"] = "4",
					["v_p_knowspell"] = "193531",
					["b_gspellcost"] = true,
					["v_gspellcost"] = "25",
					["b_p_unitpower"] = true,
					["b_p_knowspell"] = true,
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "1943",
					["b_t_needsdebuff"] = true,
					["v_keybind"] = "<keybind>",
					["v_p_unitpower"] = ">=5",
					["v_gspellcosttype"] = "3",
				},
				["defaultRotation/rogue/hemorrhage"] = {
					["b_gspellcost"] = true,
					["v_gunitpowertype"] = "4",
					["v_gspellcost"] = "30",
					["b_t_needsdebuff"] = true,
					["b_gunitpower"] = true,
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "16511",
					["v_gspellcosttype"] = "3",
					["v_keybind"] = "<keybind>",
					["v_gunitpower"] = "1",
					["v_t_needsdebuff"] = "_16511^6",
				},
				["defaultRotation/rogue/garrote_deeper_stratagem"] = {
					["v_t_needsdebuff"] = "_703^5.4",
					["v_gunitpowertype"] = "4",
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "703",
					["v_gspellcosttype"] = "3",
					["v_checkothercdvalue"] = "<1.5",
					["v_gunitpower"] = "1",
					["v_checkothercdname"] = "703",
					["b_gspellcost"] = true,
					["b_p_unitpower"] = true,
					["b_gunitpower"] = true,
					["v_p_unitpowertype"] = "4",
					["b_t_needsdebuff"] = true,
					["v_keybind"] = "<keybind>",
					["v_p_unitpower"] = "<6",
					["v_gspellcost"] = "45",
				},
				["defaultRotation/rogue/rupture"] = {
					["v_t_needsdebuff"] = "_1943^7.2",
					["v_gspellcost"] = "25",
					["v_p_knownotspell"] = "193531",
					["b_p_knownotspell"] = true,
					["v_gspellcosttype"] = "3",
					["b_gspellcost"] = true,
					["v_durationstartedtime"] = 0,
					["v_togglename"] = "Toggle 1",
					["b_p_unitpower"] = true,
					["v_spellname"] = "1943",
					["b_t_needsdebuff"] = true,
					["v_keybind"] = "<keybind>",
					["v_p_unitpower"] = ">=4",
					["v_p_unitpowertype"] = "4",
				},
				["defaultRotation/rogue/marked_for_death_anticipation"] = {
					["b_gunitpower"] = true,
					["v_p_unitpower"] = "<6",
					["v_t_needsbuff"] = "_137619",
					["v_keybind"] = "<keybind>",
					["v_gunitpowertype"] = "4",
					["v_p_unitpowertype"] = "4",
					["b_t_needsbuff"] = true,
					["b_p_unitpower"] = true,
					["b_p_knowspell"] = true,
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "137619",
					["v_p_knowspell"] = "114015",
					["v_checkothercdvalue"] = "<1.5",
					["v_gunitpower"] = "5",
					["v_checkothercdname"] = "137619",
				},
				["defaultRotation/rogue/vendetta"] = {
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "79140",
					["v_checkothercdvalue"] = "<1.5",
					["v_keybind"] = "<keybind>",
					["v_checkothercdname"] = "79140",
				},
				["defaultRotation/rogue/deadly_poison"] = {
					["v_p_needbuff"] = "2823",
					["v_p_knownotspell"] = "200802",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "2823",
					["b_p_needbuff"] = true,
					["v_keybind"] = "<keybind>",
					["b_p_knownotspell"] = true,
					["v_togglename"] = "Toggle 1",
				},
				["defaultRotation/rogue/exsanguinate"] = {
					["v_keybind"] = "<keybind>",
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["b_t_hasdebuff"] = true,
					["v_checkothercdname"] = "200806",
					["v_checkothercdvalue"] = "<1.5",
					["v_spellname"] = "200806",
					["v_t_hasdebuff"] = "1943^20",
				},
				["defaultRotation/rogue/marked_for_death_deeper_stratagem"] = {
					["b_gunitpower"] = true,
					["v_p_unitpower"] = "<2",
					["v_t_needsbuff"] = "_137619",
					["v_keybind"] = "<keybind>",
					["v_gunitpowertype"] = "4",
					["v_p_unitpowertype"] = "4",
					["b_t_needsbuff"] = true,
					["b_p_unitpower"] = true,
					["b_p_knowspell"] = true,
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "137619",
					["v_p_knowspell"] = "193531",
					["v_checkothercdvalue"] = "<1.5",
					["v_gunitpower"] = "5",
					["v_checkothercdname"] = "137619",
				},
				["defaultRotation/rogue/death_from_above_deeper_stratagem"] = {
					["b_gspellcost"] = true,
					["v_durationstartedtime"] = 0,
					["v_p_knowspell"] = "193531",
					["b_p_unitpower"] = true,
					["v_checkothercdvalue"] = "<1.5",
					["v_gspellcosttype"] = "3",
					["b_p_knowspell"] = true,
					["v_togglename"] = "Toggle 1",
					["v_p_unitpowertype"] = "4",
					["v_spellname"] = "152150",
					["v_gspellcost"] = "25",
					["v_keybind"] = "<keybind>",
					["v_p_unitpower"] = ">=5",
					["v_checkothercdname"] = "152150",
				},
				["defaultRotation/rogue/kingsbane"] = {
					["v_keybind"] = "<keybind>",
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "192759",
				},
				["defaultRotation/rogue/agonizing_poison"] = {
					["v_p_needbuff"] = "200802",
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "200802",
					["b_p_needbuff"] = true,
					["v_keybind"] = "<keybind>",
				},
			},
			["specID"] = 1,
			["version"] = 7,
		},
		["defaultRotation/rogue/outlaw_multi"] = {
			["version"] = 7,
			["SortedActions"] = {
				"defaultRotation/rogue/kick", -- [1]
				"defaultRotation/rogue/crimson_vial_iron_stomach", -- [2]
				"defaultRotation/rogue/crimson_vial", -- [3]
				"defaultRotation/rogue/blade_flurry", -- [4]
				"defaultRotation/rogue/ambush", -- [5]
				"defaultRotation/rogue/killing_spree", -- [6]
				"defaultRotation/rogue/curse_of_the_dreadblades", -- [7]
				"defaultRotation/rogue/adrenaline_rush", -- [8]
				"defaultRotation/rogue/marked_for_death_anticipation", -- [9]
				"defaultRotation/rogue/marked_for_death", -- [10]
				"defaultRotation/rogue/roll_the_bones_deeper_stratagem", -- [11]
				"defaultRotation/rogue/roll_the_bones", -- [12]
				"defaultRotation/rogue/cannonball_barrage", -- [13]
				"defaultRotation/rogue/death_from_above_deeper_stratagem", -- [14]
				"defaultRotation/rogue/death_from_above", -- [15]
				"defaultRotation/rogue/between_the_eyes_deeper_stratagem", -- [16]
				"defaultRotation/rogue/between_the_eyes", -- [17]
				"defaultRotation/rogue/run_through_deeper_stratagem", -- [18]
				"defaultRotation/rogue/run_through", -- [19]
				"defaultRotation/rogue/ghostly_strike_anticipation", -- [20]
				"defaultRotation/rogue/ghostly_strike_deeper_stratagem", -- [21]
				"defaultRotation/rogue/ghostly_strike", -- [22]
				"defaultRotation/rogue/pistol_shot_quick_draw_anticipation", -- [23]
				"defaultRotation/rogue/pistol_shot_quick_draw_deeper_stratagem", -- [24]
				"defaultRotation/rogue/pistol_shot_quick_draw", -- [25]
				"defaultRotation/rogue/pistol_shot_anticipation", -- [26]
				"defaultRotation/rogue/pistol_shot_deeper_stratagem", -- [27]
				"defaultRotation/rogue/pistol_shot", -- [28]
				"defaultRotation/rogue/saber_slash", -- [29]
			},
			["bindindex"] = 0,
			["ActionList"] = {
				["defaultRotation/rogue/pistol_shot_deeper_stratagem"] = {
					["v_p_knowspell"] = "193531",
					["v_p_unitpower"] = "<6",
					["v_gunitpowertype"] = "4",
					["v_durationstartedtime"] = 0,
					["b_gunitpower"] = true,
					["b_hasproc"] = true,
					["b_p_knowspell"] = true,
					["v_togglename"] = "Toggle 1",
					["v_p_unitpowertype"] = "4",
					["v_spellname"] = "185763",
					["v_p_knownotspell"] = "196938",
					["b_p_knownotspell"] = true,
					["v_gunitpower"] = "1",
					["b_p_unitpower"] = true,
				},
				["defaultRotation/rogue/death_from_above"] = {
					["b_gspellcost"] = true,
					["b_p_unitpower"] = true,
					["v_p_unitpowertype"] = "4",
					["v_checkothercdvalue"] = "<1.5",
					["v_gspellcosttype"] = "3",
					["v_togglename"] = "Toggle 1",
					["v_p_knownotspell"] = "193531",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "152150",
					["v_gspellcost"] = "25",
					["b_p_knownotspell"] = true,
					["v_p_unitpower"] = ">=5",
					["v_checkothercdname"] = "152150",
				},
				["defaultRotation/rogue/blade_flurry"] = {
					["b_p_needbuff"] = true,
					["v_p_needbuff"] = "13877",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "13877",
				},
				["defaultRotation/rogue/between_the_eyes_deeper_stratagem"] = {
					["b_gspellcost"] = true,
					["v_p_unitpower"] = "=6",
					["v_p_knowspell"] = "193531",
					["v_durationstartedtime"] = 0,
					["b_p_unitpower"] = true,
					["v_gspellcosttype"] = "3",
					["b_p_knowspell"] = true,
					["v_togglename"] = "Toggle 1",
					["v_p_unitpowertype"] = "4",
					["v_spellname"] = "199804",
					["v_gspellcost"] = "35",
					["v_checkothercdvalue"] = "<1.5",
					["v_p_havebuff"] = "193357",
					["v_checkothercdname"] = "199804",
				},
				["defaultRotation/rogue/pistol_shot_anticipation"] = {
					["v_p_knowspell"] = "114015",
					["v_p_unitpower"] = "<10",
					["v_gunitpowertype"] = "4",
					["v_durationstartedtime"] = 0,
					["b_gunitpower"] = true,
					["b_hasproc"] = true,
					["b_p_knowspell"] = true,
					["v_togglename"] = "Toggle 1",
					["v_p_unitpowertype"] = "4",
					["v_spellname"] = "185763",
					["v_p_knownotspell"] = "196938",
					["b_p_knownotspell"] = true,
					["v_gunitpower"] = "1",
					["b_p_unitpower"] = true,
				},
				["defaultRotation/rogue/pistol_shot"] = {
					["v_gunitpowertype"] = "4",
					["v_gunitpower"] = "1",
					["v_durationstartedtime"] = 0,
					["b_hasproc"] = true,
					["b_gunitpower"] = true,
					["v_togglename"] = "Toggle 1",
					["v_p_unitpowertype"] = "4",
					["v_spellname"] = "185763",
					["v_p_knownotspell"] = "196938||193531||114015",
					["b_p_knownotspell"] = true,
					["v_p_unitpower"] = "<5",
					["b_p_unitpower"] = true,
				},
				["defaultRotation/rogue/run_through_deeper_stratagem"] = {
					["b_gspellcost"] = true,
					["v_p_knowspell"] = "193531",
					["v_durationstartedtime"] = 0,
					["b_p_knowspell"] = true,
					["v_togglename"] = "Toggle 1",
					["b_p_unitpower"] = true,
					["v_spellname"] = "2098",
					["v_gspellcosttype"] = "3",
					["v_p_unitpowertype"] = "4",
					["v_p_unitpower"] = "=6",
					["v_gspellcost"] = "35",
				},
				["defaultRotation/rogue/pistol_shot_quick_draw_deeper_stratagem"] = {
					["v_p_knowspell"] = "196938||193531",
					["b_p_unitpower"] = true,
					["v_gunitpower"] = "2",
					["b_hasproc"] = true,
					["b_p_knowspell"] = true,
					["v_togglename"] = "Toggle 1",
					["v_p_unitpowertype"] = "4",
					["v_spellname"] = "185763",
					["v_durationstartedtime"] = 0,
					["b_gunitpower"] = true,
					["v_p_unitpower"] = "<5",
					["v_gunitpowertype"] = "4",
				},
				["defaultRotation/rogue/ambush"] = {
					["b_gspellcost"] = true,
					["v_gunitpowertype"] = "4",
					["b_p_isstealthed"] = true,
					["v_togglename"] = "Toggle 1",
					["b_gunitpower"] = true,
					["v_spellname"] = "8676",
					["v_gspellcost"] = "60",
					["v_gspellcosttype"] = "3",
					["v_gunitpower"] = "2",
					["v_durationstartedtime"] = 0,
				},
				["defaultRotation/rogue/between_the_eyes"] = {
					["b_gspellcost"] = true,
					["v_p_knownotspell"] = "193531",
					["v_p_unitpower"] = ">=5",
					["b_p_knownotspell"] = true,
					["v_gspellcosttype"] = "3",
					["v_durationstartedtime"] = 0,
					["b_p_unitpower"] = true,
					["v_togglename"] = "Toggle 1",
					["v_p_unitpowertype"] = "4",
					["v_spellname"] = "199804",
					["v_gspellcost"] = "35",
					["v_checkothercdvalue"] = "<1.5",
					["v_p_havebuff"] = "193357",
					["v_checkothercdname"] = "199804",
				},
				["defaultRotation/rogue/saber_slash"] = {
					["b_gspellcost"] = true,
					["v_gunitpowertype"] = "4",
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "193315",
					["v_gspellcost"] = "50",
					["v_gspellcosttype"] = "3",
					["v_gunitpower"] = "1",
					["b_gunitpower"] = true,
				},
				["defaultRotation/rogue/ghostly_strike"] = {
					["v_t_needsdebuff"] = "_196937^4.5",
					["v_gunitpowertype"] = "4",
					["v_p_knownotspell"] = "114015||193531",
					["b_p_unitpower"] = true,
					["v_spellname"] = "196937",
					["b_t_needsdebuff"] = true,
					["v_gunitpower"] = "1",
					["b_gspellcost"] = true,
					["v_t_needsbuff"] = " ",
					["v_togglename"] = "Toggle 1",
					["v_gspellcost"] = "30",
					["b_gunitpower"] = true,
					["v_p_unitpowertype"] = "4",
					["v_durationstartedtime"] = 0,
					["b_p_knownotspell"] = true,
					["v_p_unitpower"] = "<5",
					["v_gspellcosttype"] = "3",
				},
				["defaultRotation/rogue/ghostly_strike_anticipation"] = {
					["v_t_needsdebuff"] = "_196937^4.5",
					["v_gunitpowertype"] = "4",
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "196937",
					["v_gspellcost"] = "30",
					["v_gunitpower"] = "1",
					["b_gspellcost"] = true,
					["v_t_needsbuff"] = " ",
					["v_p_knowspell"] = "114015",
					["b_p_knowspell"] = true,
					["b_gunitpower"] = true,
					["v_gspellcosttype"] = "3",
					["b_p_unitpower"] = true,
					["v_p_unitpowertype"] = "4",
					["v_p_unitpower"] = "<8",
					["b_t_needsdebuff"] = true,
				},
				["defaultRotation/rogue/roll_the_bones_deeper_stratagem"] = {
					["b_gspellcost"] = true,
					["v_p_knowspell"] = "193531",
					["v_p_unitpowertype"] = "4",
					["v_gspellcost"] = "25",
					["v_durationstartedtime"] = 0,
					["b_p_knowspell"] = true,
					["v_togglename"] = "Toggle 1",
					["b_p_unitpower"] = true,
					["v_spellname"] = "193316",
					["v_gspellcosttype"] = "3",
					["v_p_needbuff"] = "193356^12.6||193357^12.6||193358^12.6||193359^12.6||199600^12.6||199603^12.6||_5171^12.6",
					["v_p_unitpower"] = "=6",
					["b_p_needbuff"] = true,
				},
				["defaultRotation/rogue/cannonball_barrage"] = {
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "185767",
					["v_checkothercdvalue"] = "<1.5",
					["v_checkothercdname"] = "185767",
				},
				["defaultRotation/rogue/curse_of_the_dreadblades"] = {
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "202665",
					["b_p_hp"] = true,
					["b_isCustomCase1"] = true,
					["v_p_hp"] = ">50%",
				},
				["defaultRotation/rogue/adrenaline_rush"] = {
					["b_isCustomCase1"] = true,
					["v_durationstartedtime"] = 0,
					["v_togglename"] = "Toggle 1",
					["v_p_unitpowertype"] = "3",
					["v_spellname"] = "13750",
					["b_p_unitpower"] = true,
					["v_checkothercdvalue"] = "<1.5",
					["v_p_unitpower"] = "<=66%",
					["v_checkothercdname"] = "13750",
				},
				["defaultRotation/rogue/crimson_vial_iron_stomach"] = {
					["v_p_knowspell"] = "193546",
					["b_p_knowspell"] = true,
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "185311",
					["b_p_hp"] = true,
					["v_checkothercdvalue"] = "<1.5",
					["v_p_hp"] = "<50%",
					["v_checkothercdname"] = "185311",
				},
				["defaultRotation/rogue/run_through"] = {
					["b_gspellcost"] = true,
					["v_p_unitpowertype"] = "4",
					["v_durationstartedtime"] = 0,
					["v_togglename"] = "Toggle 1",
					["v_p_knownotspell"] = "193531",
					["b_p_unitpower"] = true,
					["v_spellname"] = "2098",
					["v_gspellcosttype"] = "3",
					["b_p_knownotspell"] = true,
					["v_p_unitpower"] = ">=5",
					["v_gspellcost"] = "35",
				},
				["defaultRotation/rogue/pistol_shot_quick_draw"] = {
					["v_p_knowspell"] = "196938",
					["v_gunitpower"] = "2",
					["v_gunitpowertype"] = "4",
					["v_p_knownotspell"] = "193531||114015",
					["v_p_unitpowertype"] = "4",
					["b_hasproc"] = true,
					["b_p_knowspell"] = true,
					["v_togglename"] = "Toggle 1",
					["b_gunitpower"] = true,
					["v_spellname"] = "185763",
					["v_durationstartedtime"] = 0,
					["b_p_knownotspell"] = true,
					["v_p_unitpower"] = "<4",
					["b_p_unitpower"] = true,
				},
				["defaultRotation/rogue/ghostly_strike_deeper_stratagem"] = {
					["v_t_needsdebuff"] = "_196937^4.5",
					["v_gunitpowertype"] = "4",
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "196937",
					["v_gspellcost"] = "30",
					["v_gunitpower"] = "1",
					["b_gspellcost"] = true,
					["v_t_needsbuff"] = " ",
					["v_p_knowspell"] = "193531",
					["b_p_knowspell"] = true,
					["b_gunitpower"] = true,
					["v_p_unitpowertype"] = "4",
					["v_gspellcosttype"] = "3",
					["b_p_unitpower"] = true,
					["v_p_unitpower"] = "<6",
					["b_t_needsdebuff"] = true,
				},
				["defaultRotation/rogue/marked_for_death_anticipation"] = {
					["v_p_unitpower"] = "<5",
					["v_t_needsbuff"] = "_137619",
					["b_p_unitpower"] = true,
					["v_gunitpowertype"] = "4",
					["b_gunitpower"] = true,
					["b_t_needsbuff"] = true,
					["v_durationstartedtime"] = 0,
					["b_p_knowspell"] = true,
					["v_togglename"] = "Toggle 1",
					["v_p_unitpowertype"] = "4",
					["v_spellname"] = "137619",
					["v_p_knowspell"] = "114015",
					["v_checkothercdvalue"] = "<1.5",
					["v_gunitpower"] = "5",
					["v_checkothercdname"] = "137619",
				},
				["defaultRotation/rogue/marked_for_death"] = {
					["b_p_unitpower"] = true,
					["v_gunitpowertype"] = "4",
					["v_gunitpower"] = "5",
					["b_p_knownotspell"] = true,
					["b_gunitpower"] = true,
					["v_p_unitpowertype"] = "4",
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "137619",
					["v_p_knownotspell"] = "114015",
					["v_checkothercdvalue"] = "<1.5",
					["v_p_unitpower"] = "<=1",
					["v_checkothercdname"] = "137619",
				},
				["defaultRotation/rogue/roll_the_bones"] = {
					["b_gspellcost"] = true,
					["b_p_needbuff"] = true,
					["v_p_needbuff"] = "193356^10.8||193357^10.8||193358^10.8||193359^10.8||199600^10.8||199603^10.8||_5171^10.8",
					["v_gspellcost"] = "25",
					["v_p_knownotspell"] = "193531",
					["v_p_unitpowertype"] = "4",
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "193316",
					["v_gspellcosttype"] = "3",
					["b_p_knownotspell"] = true,
					["v_p_unitpower"] = ">=5",
					["b_p_unitpower"] = true,
				},
				["defaultRotation/rogue/pistol_shot_quick_draw_anticipation"] = {
					["v_p_knowspell"] = "196938||114015",
					["v_gunitpowertype"] = "4",
					["v_p_unitpower"] = "<9",
					["b_hasproc"] = true,
					["b_p_knowspell"] = true,
					["v_togglename"] = "Toggle 1",
					["b_gunitpower"] = true,
					["v_spellname"] = "185763",
					["v_durationstartedtime"] = 0,
					["b_p_unitpower"] = true,
					["v_gunitpower"] = "2",
					["v_p_unitpowertype"] = "4",
				},
				["defaultRotation/rogue/killing_spree"] = {
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "51690",
					["v_checkothercdvalue"] = "<1.5",
					["v_checkothercdname"] = "51690",
				},
				["defaultRotation/rogue/death_from_above_deeper_stratagem"] = {
					["b_gspellcost"] = true,
					["v_p_knowspell"] = "193531",
					["v_durationstartedtime"] = 0,
					["b_p_unitpower"] = true,
					["v_gspellcost"] = "25",
					["b_p_knowspell"] = true,
					["v_togglename"] = "Toggle 1",
					["v_p_unitpowertype"] = "4",
					["v_spellname"] = "152150",
					["v_gspellcosttype"] = "3",
					["v_checkothercdvalue"] = "<1.5",
					["v_p_unitpower"] = "=6",
					["v_checkothercdname"] = "152150",
				},
				["defaultRotation/rogue/crimson_vial"] = {
					["b_p_knownotspell"] = true,
					["v_checkothercdvalue"] = "<1.5",
					["v_p_knownotspell"] = "193546",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "185311",
					["v_p_hp"] = "<60%",
					["b_p_hp"] = true,
					["v_togglename"] = "Toggle 1",
					["v_checkothercdname"] = "185311",
				},
				["defaultRotation/rogue/kick"] = {
					["b_checkothercd"] = true,
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "1766",
					["v_checkothercdvalue"] = "<1.5",
					["b_t_interrupt"] = true,
					["v_checkothercdname"] = "1766",
				},
			},
			["specID"] = 2,
			["isMultiTarget"] = true,
		},
		["defaultRotation/rogue/subtlety"] = {
			["version"] = 7,
			["specID"] = 3,
			["ActionList"] = {
				["defaultRotation/rogue/death_from_above"] = {
					["b_gspellcost"] = true,
					["b_p_knownotspell"] = true,
					["b_p_unitpower"] = true,
					["v_keybind"] = "<keybind>",
					["v_gspellcosttype"] = "3",
					["v_togglename"] = "Toggle 1",
					["v_p_unitpowertype"] = "4",
					["v_p_knownotspell"] = "193531",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "152150",
					["v_gspellcost"] = "25",
					["v_checkothercdvalue"] = "<1.5",
					["v_p_unitpower"] = ">=5",
					["v_checkothercdname"] = "152150",
				},
				["defaultRotation/rogue/nightblade_deeper_stratagem"] = {
					["b_gspellcost"] = true,
					["v_gspellcost"] = "25",
					["v_p_knowspell"] = "193531",
					["v_p_unitpowertype"] = "4",
					["b_p_unitpower"] = true,
					["v_gspellcosttype"] = "3",
					["b_p_knowspell"] = true,
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "195452",
					["b_t_needsdebuff"] = true,
					["v_keybind"] = "<keybind>",
					["v_p_unitpower"] = "=6",
					["v_t_needsdebuff"] = "_195452^5.4",
				},
				["defaultRotation/rogue/shadowstrikes_premeditation"] = {
					["b_gspellcost"] = true,
					["b_gunitpower"] = true,
					["v_gunitpowertype"] = "4",
					["b_p_havebuff"] = true,
					["v_p_havebuff"] = "1784||185422||115191",
					["v_p_knowspell"] = "196979",
					["b_p_knowspell"] = true,
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "185438",
					["v_gspellcost"] = "40",
					["v_keybind"] = "<keybind>",
					["v_gunitpower"] = "2",
					["v_gspellcosttype"] = "3",
				},
				["defaultRotation/rogue/crimson_vial"] = {
					["v_p_hp"] = "<60%",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "185311",
					["v_keybind"] = "<keybind>",
					["b_p_hp"] = true,
					["v_togglename"] = "Toggle 1",
				},
				["defaultRotation/rogue/nightblade"] = {
					["b_gspellcost"] = true,
					["v_durationstartedtime"] = 0,
					["v_togglename"] = "Toggle 1",
					["b_p_knownotspell"] = true,
					["b_t_needsdebuff"] = true,
					["v_t_needsdebuff"] = "_195452^4.8",
					["b_p_unitpower"] = true,
					["v_p_knownotspell"] = "193531",
					["v_p_unitpowertype"] = "4",
					["v_spellname"] = "195452",
					["v_gspellcost"] = "25",
					["v_keybind"] = "<keybind>",
					["v_p_unitpower"] = ">=5",
					["v_gspellcosttype"] = "3",
				},
				["defaultRotation/rogue/goremaw_s_bite"] = {
					["v_p_unitpower2type"] = "4",
					["v_gunitpowertype"] = "4",
					["v_p_unitpower2"] = "<=2",
					["v_p_unitpowertype"] = "3",
					["b_gunitpower"] = true,
					["v_togglename"] = "Toggle 1",
					["b_p_unitpower2"] = true,
					["v_spellname"] = "209782",
					["v_durationstartedtime"] = 0,
					["v_keybind"] = "<keybind>",
					["v_gunitpower"] = "3",
					["v_p_unitpower"] = "<60%",
				},
				["defaultRotation/rogue/shadow_dance"] = {
					["v_p_needbuff"] = "185422||115191",
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_charges"] = ">=2",
					["b_p_needbuff"] = true,
					["v_keybind"] = "<keybind>",
					["v_spellname"] = "185313",
					["b_charges"] = true,
				},
				["defaultRotation/rogue/enveloping_shadows"] = {
					["v_p_needbuff"] = "206237^9",
					["v_togglename"] = "Toggle 1",
					["b_p_needbuff"] = true,
					["v_keybind"] = "<keybind>",
					["v_gspellcosttype"] = "3",
					["v_p_unitpowertype"] = "4",
					["b_gspellcost"] = true,
					["v_p_knownotspell"] = "193531",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "206237",
					["v_gspellcost"] = "30",
					["b_p_knownotspell"] = true,
					["v_p_unitpower"] = ">=5",
					["b_p_unitpower"] = true,
				},
				["defaultRotation/rogue/eviscerate"] = {
					["b_gspellcost"] = true,
					["v_durationstartedtime"] = 0,
					["b_p_knownotspell"] = true,
					["v_gspellcosttype"] = "3",
					["v_p_knownotspell"] = "193531",
					["v_togglename"] = "Toggle 1",
					["b_p_unitpower"] = true,
					["v_spellname"] = "196819",
					["v_gspellcost"] = "35",
					["v_keybind"] = "<keybind>",
					["v_p_unitpower"] = ">=5",
					["v_p_unitpowertype"] = "4",
				},
				["defaultRotation/rogue/backstab_anticipation"] = {
					["b_gspellcost"] = true,
					["v_p_knowspell"] = "114015",
					["b_gunitpower"] = true,
					["v_p_unitpowertype"] = "4",
					["v_gunitpowertype"] = "4",
					["v_gspellcosttype"] = "3",
					["v_p_needbuff"] = "1784||185422",
					["b_p_needbuff"] = true,
					["b_p_knowspell"] = true,
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "53",
					["v_gspellcost"] = "35",
					["v_keybind"] = "<keybind>",
					["v_gunitpower"] = "1",
					["v_p_unitpower"] = "<10",
				},
				["defaultRotation/rogue/eviscerate_deeper_stratagem"] = {
					["b_gspellcost"] = true,
					["v_p_knowspell"] = "193531",
					["b_p_unitpower"] = true,
					["v_durationstartedtime"] = 0,
					["b_p_knowspell"] = true,
					["v_togglename"] = "Toggle 1",
					["v_p_unitpowertype"] = "4",
					["v_spellname"] = "196819",
					["v_gspellcosttype"] = "3",
					["v_keybind"] = "<keybind>",
					["v_p_unitpower"] = "=6",
					["v_gspellcost"] = "35",
				},
				["defaultRotation/rogue/shadow_dance_symbols_of_death"] = {
					["v_p_needbuff"] = "212283^10.5||185422||115191",
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "185313",
					["b_p_needbuff"] = true,
					["v_keybind"] = "<keybind>",
					["v_charges"] = ">0",
					["b_charges"] = true,
				},
				["defaultRotation/rogue/backstab"] = {
					["v_p_needbuff"] = "1784||185422",
					["v_durationstartedtime"] = 0,
					["v_p_unitpower"] = "<5",
					["b_p_knownotspell"] = true,
					["b_p_needbuff"] = true,
					["v_gunitpowertype"] = "4",
					["b_gunitpower"] = true,
					["v_p_knownotspell"] = "193531||114015",
					["b_gspellcost"] = true,
					["v_togglename"] = "Toggle 1",
					["v_p_unitpowertype"] = "4",
					["v_spellname"] = "53",
					["v_gspellcost"] = "35",
					["v_keybind"] = "<keybind>",
					["v_gunitpower"] = "1",
					["v_gspellcosttype"] = "3",
				},
				["defaultRotation/rogue/enveloping_shadows_deeper_stratagem"] = {
					["b_gspellcost"] = true,
					["v_p_unitpowertype"] = "4",
					["v_p_knowspell"] = "193531",
					["v_p_needbuff"] = "206237^10.8",
					["b_p_unitpower"] = true,
					["v_gspellcost"] = "30",
					["b_p_knowspell"] = true,
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "206237",
					["v_gspellcosttype"] = "3",
					["v_keybind"] = "<keybind>",
					["v_p_unitpower"] = "=6",
					["b_p_needbuff"] = true,
				},
				["defaultRotation/rogue/shadowstrikes"] = {
					["b_gspellcost"] = true,
					["v_p_knownotspell"] = "196979",
					["v_gunitpowertype"] = "4",
					["b_p_knownotspell"] = true,
					["v_gspellcost"] = "40",
					["b_p_havebuff"] = true,
					["b_gunitpower"] = true,
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "185438",
					["v_gspellcosttype"] = "3",
					["v_keybind"] = "<keybind>",
					["v_gunitpower"] = "1",
					["v_p_havebuff"] = "1784||185422||115191",
				},
				["defaultRotation/rogue/marked_for_death_anticipation"] = {
					["v_t_needsbuff"] = "_137619",
					["v_p_unitpower"] = "<5",
					["v_gunitpowertype"] = "4",
					["b_gunitpower"] = true,
					["b_t_needsbuff"] = true,
					["v_p_unitpowertype"] = "4",
					["b_p_knowspell"] = true,
					["v_togglename"] = "Toggle 1",
					["b_p_unitpower"] = true,
					["v_spellname"] = "137619",
					["v_durationstartedtime"] = 0,
					["v_keybind"] = "<keybind>",
					["v_gunitpower"] = "5",
					["v_p_knowspell"] = "114015",
				},
				["defaultRotation/rogue/shadow_blades"] = {
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "121471",
					["v_keybind"] = "<keybind>",
					["v_checkothercdvalue"] = "<1.5",
					["b_isCustomCase1"] = true,
					["v_checkothercdname"] = "121471",
				},
				["defaultRotation/rogue/symbols_of_death"] = {
					["v_p_needbuff"] = "212283^10.5",
					["b_p_needbuff"] = true,
					["b_gspellcost"] = true,
					["v_keybind"] = "<keybind>",
					["v_gspellcost"] = "35",
					["v_durationstartedtime"] = 0,
					["v_togglename"] = "Toggle 1",
					["b_p_havebuff"] = true,
					["v_spellname"] = "212283",
					["v_gspellcosttype"] = "3",
					["v_checkothercdvalue"] = "<1.5",
					["v_p_havebuff"] = "1784||185422||115192",
					["v_checkothercdname"] = "212283",
				},
				["defaultRotation/rogue/marked_for_death"] = {
					["b_p_knownotspell"] = true,
					["v_p_unitpower"] = "<1",
					["v_t_needsbuff"] = "_137619",
					["v_keybind"] = "<keybind>",
					["v_gunitpowertype"] = "4",
					["v_durationstartedtime"] = 0,
					["b_t_needsbuff"] = true,
					["v_togglename"] = "Toggle 1",
					["b_gunitpower"] = true,
					["v_p_knownotspell"] = "193531||114015",
					["v_p_unitpowertype"] = "4",
					["v_spellname"] = "137619",
					["b_p_unitpower"] = true,
					["v_checkothercdvalue"] = "<1.5",
					["v_gunitpower"] = "5",
					["v_checkothercdname"] = "137619",
				},
				["defaultRotation/rogue/marked_for_death_deeper_stratagem"] = {
					["v_t_needsbuff"] = "_137619",
					["v_p_unitpower"] = "<1",
					["v_gunitpowertype"] = "4",
					["b_p_unitpower"] = true,
					["b_t_needsbuff"] = true,
					["v_p_unitpowertype"] = "4",
					["b_p_knowspell"] = true,
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "137619",
					["b_gunitpower"] = true,
					["v_keybind"] = "<keybind>",
					["v_gunitpower"] = "5",
					["v_p_knowspell"] = "193531",
				},
				["defaultRotation/rogue/death_from_above_deeper_stratagem"] = {
					["b_gspellcost"] = true,
					["b_p_unitpower"] = true,
					["v_p_knowspell"] = "193531",
					["v_p_unitpowertype"] = "4",
					["v_keybind"] = "<keybind>",
					["v_gspellcosttype"] = "3",
					["b_p_knowspell"] = true,
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "152150",
					["v_gspellcost"] = "25",
					["v_checkothercdvalue"] = "<1.5",
					["v_p_unitpower"] = "=6",
					["v_checkothercdname"] = "152150",
				},
				["defaultRotation/rogue/kick"] = {
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "1766",
					["v_keybind"] = "<keybind>",
					["v_checkothercdvalue"] = "<1.5",
					["b_t_interrupt"] = true,
					["v_checkothercdname"] = "1766",
				},
				["defaultRotation/rogue/backstab_deeper_stratagem"] = {
					["b_gspellcost"] = true,
					["v_p_unitpowertype"] = "4",
					["v_p_unitpower"] = "<6",
					["v_gspellcost"] = "35",
					["v_p_knowspell"] = "193531",
					["v_p_needbuff"] = "1784||185422",
					["v_gunitpowertype"] = "4",
					["b_gunitpower"] = true,
					["b_p_knowspell"] = true,
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "53",
					["v_gspellcosttype"] = "3",
					["v_keybind"] = "<keybind>",
					["v_gunitpower"] = "1",
					["b_p_needbuff"] = true,
				},
			},
			["SortedActions"] = {
				"defaultRotation/rogue/kick", -- [1]
				"defaultRotation/rogue/crimson_vial", -- [2]
				"defaultRotation/rogue/marked_for_death_anticipation", -- [3]
				"defaultRotation/rogue/marked_for_death_deeper_stratagem", -- [4]
				"defaultRotation/rogue/marked_for_death", -- [5]
				"defaultRotation/rogue/symbols_of_death", -- [6]
				"defaultRotation/rogue/nightblade_deeper_stratagem", -- [7]
				"defaultRotation/rogue/nightblade", -- [8]
				"defaultRotation/rogue/enveloping_shadows_deeper_stratagem", -- [9]
				"defaultRotation/rogue/enveloping_shadows", -- [10]
				"defaultRotation/rogue/death_from_above_deeper_stratagem", -- [11]
				"defaultRotation/rogue/death_from_above", -- [12]
				"defaultRotation/rogue/eviscerate_deeper_stratagem", -- [13]
				"defaultRotation/rogue/eviscerate", -- [14]
				"defaultRotation/rogue/shadowstrikes_premeditation", -- [15]
				"defaultRotation/rogue/shadowstrikes", -- [16]
				"defaultRotation/rogue/shadow_dance_symbols_of_death", -- [17]
				"defaultRotation/rogue/shadow_dance", -- [18]
				"defaultRotation/rogue/goremaw_s_bite", -- [19]
				"defaultRotation/rogue/shadow_blades", -- [20]
				"defaultRotation/rogue/backstab_anticipation", -- [21]
				"defaultRotation/rogue/backstab_deeper_stratagem", -- [22]
				"defaultRotation/rogue/backstab", -- [23]
			},
			["bindindex"] = 0,
		},
		["defaultRotation/rogue/outlaw"] = {
			["SortedActions"] = {
				"defaultRotation/rogue/kick", -- [1]
				"defaultRotation/rogue/crimson_vial_iron_stomach", -- [2]
				"defaultRotation/rogue/crimson_vial", -- [3]
				"defaultRotation/rogue/ambush", -- [4]
				"defaultRotation/rogue/killing_spree", -- [5]
				"defaultRotation/rogue/curse_of_the_dreadblades", -- [6]
				"defaultRotation/rogue/adrenaline_rush", -- [7]
				"defaultRotation/rogue/marked_for_death_anticipation", -- [8]
				"defaultRotation/rogue/marked_for_death", -- [9]
				"defaultRotation/rogue/roll_the_bones_deeper_stratagem", -- [10]
				"defaultRotation/rogue/roll_the_bones", -- [11]
				"defaultRotation/rogue/cannonball_barrage", -- [12]
				"defaultRotation/rogue/between_the_eyes_deeper_stratagem", -- [13]
				"defaultRotation/rogue/between_the_eyes", -- [14]
				"defaultRotation/rogue/death_from_above_deeper_stratagem", -- [15]
				"defaultRotation/rogue/death_from_above", -- [16]
				"defaultRotation/rogue/run_through_deeper_stratagem", -- [17]
				"defaultRotation/rogue/run_through", -- [18]
				"defaultRotation/rogue/ghostly_strike_anticipation", -- [19]
				"defaultRotation/rogue/ghostly_strike_deeper_stratagem", -- [20]
				"defaultRotation/rogue/ghostly_strike", -- [21]
				"defaultRotation/rogue/pistol_shot_quick_draw_anticipation", -- [22]
				"defaultRotation/rogue/pistol_shot_quick_draw_deeper_stratagem", -- [23]
				"defaultRotation/rogue/pistol_shot_quick_draw", -- [24]
				"defaultRotation/rogue/pistol_shot_anticipation", -- [25]
				"defaultRotation/rogue/pistol_shot_deeper_stratagem", -- [26]
				"defaultRotation/rogue/pistol_shot", -- [27]
				"defaultRotation/rogue/saber_slash", -- [28]
			},
			["version"] = 7,
			["ActionList"] = {
				["defaultRotation/rogue/pistol_shot_deeper_stratagem"] = {
					["v_p_unitpower"] = "<6",
					["v_p_knowspell"] = "193531",
					["v_gunitpowertype"] = "4",
					["v_p_unitpowertype"] = "4",
					["b_gunitpower"] = true,
					["b_hasproc"] = true,
					["b_p_knowspell"] = true,
					["v_p_knownotspell"] = "196938",
					["b_p_unitpower"] = true,
					["v_spellname"] = "185763",
					["v_togglename"] = "Toggle 1",
					["b_p_knownotspell"] = true,
					["v_gunitpower"] = "1",
					["v_durationstartedtime"] = 0,
				},
				["defaultRotation/rogue/death_from_above"] = {
					["b_gspellcost"] = true,
					["b_p_unitpower"] = true,
					["v_checkothercdvalue"] = "<1.5",
					["v_gspellcosttype"] = "3",
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_p_knownotspell"] = "193531",
					["v_p_unitpowertype"] = "4",
					["v_spellname"] = "152150",
					["v_gspellcost"] = "25",
					["b_p_knownotspell"] = true,
					["v_p_unitpower"] = ">=5",
					["v_checkothercdname"] = "152150",
				},
				["defaultRotation/rogue/crimson_vial"] = {
					["b_p_hp"] = true,
					["v_checkothercdvalue"] = "<1.5",
					["v_p_hp"] = "<60%",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "185311",
					["v_togglename"] = "Toggle 1",
					["b_p_knownotspell"] = true,
					["v_p_knownotspell"] = "193546",
					["v_checkothercdname"] = "185311",
				},
				["defaultRotation/rogue/run_through_deeper_stratagem"] = {
					["b_gspellcost"] = true,
					["v_p_knowspell"] = "193531",
					["v_gspellcosttype"] = "3",
					["b_p_knowspell"] = true,
					["v_togglename"] = "Toggle 1",
					["v_p_unitpowertype"] = "4",
					["v_spellname"] = "2098",
					["v_gspellcost"] = "35",
					["b_p_unitpower"] = true,
					["v_p_unitpower"] = "=6",
					["v_durationstartedtime"] = 0,
				},
				["defaultRotation/rogue/kick"] = {
					["b_checkothercd"] = true,
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "1766",
					["v_checkothercdvalue"] = "<1.5",
					["b_t_interrupt"] = true,
					["v_checkothercdname"] = "1766",
				},
				["defaultRotation/rogue/pistol_shot_anticipation"] = {
					["v_p_unitpower"] = "<10",
					["v_durationstartedtime"] = 0,
					["v_gunitpowertype"] = "4",
					["b_gunitpower"] = true,
					["v_p_knowspell"] = "114015",
					["b_hasproc"] = true,
					["b_p_knowspell"] = true,
					["v_p_knownotspell"] = "196938",
					["b_p_unitpower"] = true,
					["v_spellname"] = "185763",
					["v_togglename"] = "Toggle 1",
					["b_p_knownotspell"] = true,
					["v_gunitpower"] = "1",
					["v_p_unitpowertype"] = "4",
				},
				["defaultRotation/rogue/curse_of_the_dreadblades"] = {
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "202665",
					["b_p_hp"] = true,
					["b_isCustomCase1"] = true,
					["v_p_hp"] = ">50%",
				},
				["defaultRotation/rogue/ambush"] = {
					["b_gspellcost"] = true,
					["v_gunitpowertype"] = "4",
					["b_p_isstealthed"] = true,
					["v_togglename"] = "Toggle 1",
					["b_gunitpower"] = true,
					["v_spellname"] = "8676",
					["v_gspellcost"] = "60",
					["v_gspellcosttype"] = "3",
					["v_gunitpower"] = "2",
					["v_durationstartedtime"] = 0,
				},
				["defaultRotation/rogue/between_the_eyes"] = {
					["b_gspellcost"] = true,
					["v_p_unitpower"] = ">=5",
					["b_p_knownotspell"] = true,
					["v_gspellcost"] = "35",
					["b_p_unitpower"] = true,
					["v_durationstartedtime"] = 0,
					["v_togglename"] = "Toggle 1",
					["v_p_knownotspell"] = "193531",
					["v_p_unitpowertype"] = "4",
					["v_spellname"] = "199804",
					["v_gspellcosttype"] = "3",
					["v_checkothercdvalue"] = "<1.5",
					["v_p_havebuff"] = "193357",
					["v_checkothercdname"] = "199804",
				},
				["defaultRotation/rogue/saber_slash"] = {
					["b_gspellcost"] = true,
					["v_gunitpowertype"] = "4",
					["v_togglename"] = "Toggle 1",
					["b_gunitpower"] = true,
					["v_spellname"] = "193315",
					["v_gspellcosttype"] = "3",
					["v_gspellcost"] = "50",
					["v_gunitpower"] = "1",
					["v_durationstartedtime"] = 0,
				},
				["defaultRotation/rogue/ghostly_strike"] = {
					["v_t_needsdebuff"] = "_196937^4.5",
					["v_gunitpowertype"] = "4",
					["v_p_knownotspell"] = "114015||193531",
					["b_p_unitpower"] = true,
					["v_spellname"] = "196937",
					["b_t_needsdebuff"] = true,
					["v_gunitpower"] = "1",
					["b_gspellcost"] = true,
					["v_t_needsbuff"] = " ",
					["v_p_unitpowertype"] = "4",
					["v_gspellcosttype"] = "3",
					["b_gunitpower"] = true,
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["b_p_knownotspell"] = true,
					["v_p_unitpower"] = "<5",
					["v_gspellcost"] = "30",
				},
				["defaultRotation/rogue/ghostly_strike_anticipation"] = {
					["v_t_needsdebuff"] = "_196937^4.5",
					["v_gunitpowertype"] = "4",
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "196937",
					["v_gspellcost"] = "30",
					["v_gunitpower"] = "1",
					["b_gspellcost"] = true,
					["v_t_needsbuff"] = " ",
					["v_p_knowspell"] = "114015",
					["b_p_knowspell"] = true,
					["b_gunitpower"] = true,
					["v_gspellcosttype"] = "3",
					["b_p_unitpower"] = true,
					["v_p_unitpowertype"] = "4",
					["v_p_unitpower"] = "<8",
					["b_t_needsdebuff"] = true,
				},
				["defaultRotation/rogue/roll_the_bones_deeper_stratagem"] = {
					["b_gspellcost"] = true,
					["v_p_knowspell"] = "193531",
					["v_gspellcost"] = "25",
					["b_p_unitpower"] = true,
					["v_p_needbuff"] = "193356^12.6||193357^12.6||193358^12.6||193359^12.6||199600^12.6||199603^12.6||_5171^12.6",
					["b_p_knowspell"] = true,
					["v_togglename"] = "Toggle 1",
					["v_p_unitpowertype"] = "4",
					["v_spellname"] = "193316",
					["v_gspellcosttype"] = "3",
					["v_durationstartedtime"] = 0,
					["v_p_unitpower"] = "=6",
					["b_p_needbuff"] = true,
				},
				["defaultRotation/rogue/cannonball_barrage"] = {
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "185767",
					["v_checkothercdvalue"] = "<1.5",
					["v_checkothercdname"] = "185767",
				},
				["defaultRotation/rogue/adrenaline_rush"] = {
					["b_isCustomCase1"] = true,
					["v_durationstartedtime"] = 0,
					["v_togglename"] = "Toggle 1",
					["b_p_unitpower"] = true,
					["v_spellname"] = "13750",
					["v_p_unitpowertype"] = "3",
					["v_checkothercdvalue"] = "<1.5",
					["v_p_unitpower"] = "<=66%",
					["v_checkothercdname"] = "13750",
				},
				["defaultRotation/rogue/pistol_shot_quick_draw_deeper_stratagem"] = {
					["b_p_unitpower"] = true,
					["v_p_knowspell"] = "196938||193531",
					["v_p_unitpower"] = "<5",
					["b_hasproc"] = true,
					["b_p_knowspell"] = true,
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "185763",
					["v_p_unitpowertype"] = "4",
					["b_gunitpower"] = true,
					["v_gunitpower"] = "2",
					["v_gunitpowertype"] = "4",
				},
				["defaultRotation/rogue/crimson_vial_iron_stomach"] = {
					["v_p_knowspell"] = "193546",
					["b_p_knowspell"] = true,
					["v_p_hp"] = "<50%",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "185311",
					["b_p_hp"] = true,
					["v_checkothercdvalue"] = "<1.5",
					["v_togglename"] = "Toggle 1",
					["v_checkothercdname"] = "185311",
				},
				["defaultRotation/rogue/run_through"] = {
					["b_gspellcost"] = true,
					["b_p_unitpower"] = true,
					["v_p_unitpowertype"] = "4",
					["v_p_knownotspell"] = "193531",
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "2098",
					["v_gspellcost"] = "35",
					["b_p_knownotspell"] = true,
					["v_p_unitpower"] = ">=5",
					["v_gspellcosttype"] = "3",
				},
				["defaultRotation/rogue/pistol_shot_quick_draw"] = {
					["v_gunitpower"] = "2",
					["v_durationstartedtime"] = 0,
					["v_p_knowspell"] = "196938",
					["v_togglename"] = "Toggle 1",
					["b_p_unitpower"] = true,
					["b_hasproc"] = true,
					["b_p_knowspell"] = true,
					["v_p_knownotspell"] = "193531||114015",
					["b_gunitpower"] = true,
					["v_spellname"] = "185763",
					["v_p_unitpowertype"] = "4",
					["b_p_knownotspell"] = true,
					["v_p_unitpower"] = "<4",
					["v_gunitpowertype"] = "4",
				},
				["defaultRotation/rogue/ghostly_strike_deeper_stratagem"] = {
					["v_t_needsdebuff"] = "_196937^4.5",
					["v_gunitpowertype"] = "4",
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "196937",
					["v_gspellcost"] = "30",
					["v_gunitpower"] = "1",
					["b_gspellcost"] = true,
					["v_t_needsbuff"] = " ",
					["v_p_knowspell"] = "193531",
					["b_p_knowspell"] = true,
					["b_gunitpower"] = true,
					["v_gspellcosttype"] = "3",
					["b_p_unitpower"] = true,
					["v_p_unitpowertype"] = "4",
					["v_p_unitpower"] = "<6",
					["b_t_needsdebuff"] = true,
				},
				["defaultRotation/rogue/marked_for_death_anticipation"] = {
					["v_p_unitpower"] = "<5",
					["v_t_needsbuff"] = "_137619",
					["v_durationstartedtime"] = 0,
					["v_gunitpowertype"] = "4",
					["b_p_unitpower"] = true,
					["b_t_needsbuff"] = true,
					["b_gunitpower"] = true,
					["b_p_knowspell"] = true,
					["v_togglename"] = "Toggle 1",
					["v_p_unitpowertype"] = "4",
					["v_spellname"] = "137619",
					["v_p_knowspell"] = "114015",
					["v_checkothercdvalue"] = "<1.5",
					["v_gunitpower"] = "5",
					["v_checkothercdname"] = "137619",
				},
				["defaultRotation/rogue/marked_for_death"] = {
					["v_p_unitpower"] = "<=1",
					["v_gunitpowertype"] = "4",
					["b_p_knownotspell"] = true,
					["b_p_unitpower"] = true,
					["v_p_knownotspell"] = "114015",
					["b_gunitpower"] = true,
					["v_togglename"] = "Toggle 1",
					["v_p_unitpowertype"] = "4",
					["v_spellname"] = "137619",
					["v_durationstartedtime"] = 0,
					["v_checkothercdvalue"] = "<1.5",
					["v_gunitpower"] = "5",
					["v_checkothercdname"] = "137619",
				},
				["defaultRotation/rogue/roll_the_bones"] = {
					["b_gspellcost"] = true,
					["b_p_needbuff"] = true,
					["v_p_knownotspell"] = "193531",
					["v_p_needbuff"] = "193356^10.8||193357^10.8||193358^10.8||193359^10.8||199600^10.8||199603^10.8||_5171^10.8",
					["v_gspellcost"] = "25",
					["v_p_unitpowertype"] = "4",
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "193316",
					["v_gspellcosttype"] = "3",
					["b_p_knownotspell"] = true,
					["v_p_unitpower"] = ">=5",
					["b_p_unitpower"] = true,
				},
				["defaultRotation/rogue/pistol_shot_quick_draw_anticipation"] = {
					["v_durationstartedtime"] = 0,
					["v_p_knowspell"] = "196938||114015",
					["v_p_unitpower"] = "<9",
					["b_p_unitpower"] = true,
					["b_hasproc"] = true,
					["b_p_knowspell"] = true,
					["v_togglename"] = "Toggle 1",
					["v_p_unitpowertype"] = "4",
					["v_spellname"] = "185763",
					["b_gunitpower"] = true,
					["v_gunitpower"] = "2",
					["v_gunitpowertype"] = "4",
				},
				["defaultRotation/rogue/killing_spree"] = {
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "51690",
					["v_checkothercdvalue"] = "<1.5",
					["v_checkothercdname"] = "51690",
				},
				["defaultRotation/rogue/death_from_above_deeper_stratagem"] = {
					["b_gspellcost"] = true,
					["v_p_knowspell"] = "193531",
					["v_durationstartedtime"] = 0,
					["v_p_unitpowertype"] = "4",
					["v_gspellcost"] = "25",
					["b_p_knowspell"] = true,
					["v_togglename"] = "Toggle 1",
					["b_p_unitpower"] = true,
					["v_spellname"] = "152150",
					["v_gspellcosttype"] = "3",
					["v_checkothercdvalue"] = "<1.5",
					["v_p_unitpower"] = "=6",
					["v_checkothercdname"] = "152150",
				},
				["defaultRotation/rogue/between_the_eyes_deeper_stratagem"] = {
					["b_gspellcost"] = true,
					["v_p_unitpower"] = "=6",
					["v_p_knowspell"] = "193531",
					["v_durationstartedtime"] = 0,
					["v_gspellcost"] = "35",
					["v_p_unitpowertype"] = "4",
					["b_p_knowspell"] = true,
					["v_togglename"] = "Toggle 1",
					["b_p_unitpower"] = true,
					["v_spellname"] = "199804",
					["v_gspellcosttype"] = "3",
					["v_checkothercdvalue"] = "<1.5",
					["v_p_havebuff"] = "193357",
					["v_checkothercdname"] = "199804",
				},
				["defaultRotation/rogue/pistol_shot"] = {
					["v_gunitpower"] = "1",
					["v_gunitpowertype"] = "4",
					["v_durationstartedtime"] = 0,
					["v_p_knownotspell"] = "196938||193531||114015",
					["b_hasproc"] = true,
					["b_gunitpower"] = true,
					["v_togglename"] = "Toggle 1",
					["b_p_unitpower"] = true,
					["v_spellname"] = "185763",
					["v_p_unitpowertype"] = "4",
					["b_p_knownotspell"] = true,
					["v_p_unitpower"] = "<5",
				},
			},
			["specID"] = 2,
			["bindindex"] = 0,
		},
		["defaultRotation/rogue/assassination_multi"] = {
			["version"] = 7,
			["SortedActions"] = {
				"defaultRotation/rogue/kick", -- [1]
				"defaultRotation/rogue/agonizing_poison", -- [2]
				"defaultRotation/rogue/deadly_poison", -- [3]
				"defaultRotation/rogue/leeching_poison", -- [4]
				"defaultRotation/rogue/crimson_vial", -- [5]
				"defaultRotation/rogue/marked_for_death_anticipation", -- [6]
				"defaultRotation/rogue/marked_for_death_deeper_stratagem", -- [7]
				"defaultRotation/rogue/marked_for_death", -- [8]
				"defaultRotation/rogue/death_from_above_deeper_stratagem", -- [9]
				"defaultRotation/rogue/death_from_above", -- [10]
				"defaultRotation/rogue/rupture_deeper_stratagem", -- [11]
				"defaultRotation/rogue/rupture", -- [12]
				"defaultRotation/rogue/envenom_deeper_stratagem", -- [13]
				"defaultRotation/rogue/envenom", -- [14]
				"defaultRotation/rogue/garrote", -- [15]
				"defaultRotation/rogue/garrote_deeper_stratagem", -- [16]
				"defaultRotation/rogue/vendetta", -- [17]
				"defaultRotation/rogue/exsanguinate", -- [18]
				"defaultRotation/rogue/hemorrhage", -- [19]
				"defaultRotation/rogue/kingsbane", -- [20]
				"defaultRotation/rogue/fan_of_knives", -- [21]
			},
			["bindindex"] = 0,
			["ActionList"] = {
				["defaultRotation/rogue/death_from_above"] = {
					["b_gspellcost"] = true,
					["b_p_knownotspell"] = true,
					["b_p_unitpower"] = true,
					["v_keybind"] = "<keybind>",
					["v_gspellcost"] = "25",
					["v_p_knownotspell"] = "193531",
					["v_p_unitpowertype"] = "4",
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "152150",
					["v_gspellcosttype"] = "3",
					["v_checkothercdvalue"] = "<1.5",
					["v_p_unitpower"] = ">=4",
					["v_checkothercdname"] = "152150",
				},
				["defaultRotation/rogue/envenom_deeper_stratagem"] = {
					["b_gspellcost"] = true,
					["v_p_knowspell"] = "193531",
					["v_durationstartedtime"] = 0,
					["v_gspellcosttype"] = "3",
					["b_p_knowspell"] = true,
					["v_togglename"] = "Toggle 1",
					["b_p_unitpower"] = true,
					["v_spellname"] = "32645",
					["v_gspellcost"] = "35",
					["v_keybind"] = "<keybind>",
					["v_p_unitpower"] = ">=5",
					["v_p_unitpowertype"] = "4",
				},
				["defaultRotation/rogue/leeching_poison"] = {
					["v_p_needbuff"] = "108211",
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "108211",
					["b_p_needbuff"] = true,
					["v_keybind"] = "<keybind>",
				},
				["defaultRotation/rogue/crimson_vial"] = {
					["v_togglename"] = "Toggle 1",
					["v_p_hp"] = "<60%",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "185311",
					["v_keybind"] = "<keybind>",
					["v_checkothercdvalue"] = "<1.5",
					["b_p_hp"] = true,
					["v_checkothercdname"] = "185311",
				},
				["defaultRotation/rogue/kick"] = {
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "1766",
					["v_keybind"] = "<keybind>",
					["v_checkothercdvalue"] = "<1.5",
					["b_t_interrupt"] = true,
					["v_checkothercdname"] = "1766",
				},
				["defaultRotation/rogue/garrote"] = {
					["v_t_needsdebuff"] = "_703^5.4",
					["v_gunitpowertype"] = "4",
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "703",
					["v_gspellcosttype"] = "3",
					["v_checkothercdvalue"] = "<1.5",
					["v_gunitpower"] = "1",
					["v_checkothercdname"] = "703",
					["b_gspellcost"] = true,
					["b_p_unitpower"] = true,
					["b_gunitpower"] = true,
					["v_p_unitpowertype"] = "4",
					["b_t_needsdebuff"] = true,
					["v_keybind"] = "<keybind>",
					["v_p_unitpower"] = "<5",
					["v_gspellcost"] = "45",
				},
				["defaultRotation/rogue/garrote_deeper_stratagem"] = {
					["v_t_needsdebuff"] = "_703^5.4",
					["v_gunitpowertype"] = "4",
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "703",
					["v_gspellcosttype"] = "3",
					["v_checkothercdvalue"] = "<1.5",
					["v_gunitpower"] = "1",
					["v_checkothercdname"] = "703",
					["b_gspellcost"] = true,
					["b_p_unitpower"] = true,
					["b_gunitpower"] = true,
					["v_p_unitpowertype"] = "4",
					["b_t_needsdebuff"] = true,
					["v_keybind"] = "<keybind>",
					["v_p_unitpower"] = "<6",
					["v_gspellcost"] = "45",
				},
				["defaultRotation/rogue/envenom"] = {
					["b_gspellcost"] = true,
					["v_durationstartedtime"] = 0,
					["v_togglename"] = "Toggle 1",
					["v_keybind"] = "<keybind>",
					["v_gspellcosttype"] = "3",
					["v_p_knownotspell"] = "193531",
					["v_p_unitpowertype"] = "4",
					["v_spellname"] = "32645",
					["v_gspellcost"] = "35",
					["b_p_knownotspell"] = true,
					["v_p_unitpower"] = ">=4",
					["b_p_unitpower"] = true,
				},
				["defaultRotation/rogue/marked_for_death"] = {
					["v_togglename"] = "Toggle 1",
					["v_p_unitpower"] = "<1",
					["v_t_needsbuff"] = "_137619",
					["b_p_knownotspell"] = true,
					["v_gunitpowertype"] = "4",
					["v_keybind"] = "<keybind>",
					["b_t_needsbuff"] = true,
					["v_p_unitpowertype"] = "4",
					["b_gunitpower"] = true,
					["v_p_knownotspell"] = "114015||193531",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "137619",
					["b_p_unitpower"] = true,
					["v_checkothercdvalue"] = "<1.5",
					["v_gunitpower"] = "5",
					["v_checkothercdname"] = "137619",
				},
				["defaultRotation/rogue/rupture_deeper_stratagem"] = {
					["v_t_needsdebuff"] = "_1943^8.4",
					["v_gspellcost"] = "25",
					["v_p_knowspell"] = "193531",
					["b_gspellcost"] = true,
					["b_p_unitpower"] = true,
					["v_gspellcosttype"] = "3",
					["b_p_knowspell"] = true,
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "1943",
					["b_t_needsdebuff"] = true,
					["v_keybind"] = "<keybind>",
					["v_p_unitpower"] = ">=5",
					["v_p_unitpowertype"] = "4",
				},
				["defaultRotation/rogue/hemorrhage"] = {
					["b_gspellcost"] = true,
					["v_gunitpowertype"] = "4",
					["v_t_needsdebuff"] = "_16511^6",
					["b_t_needsdebuff"] = true,
					["v_durationstartedtime"] = 0,
					["v_togglename"] = "Toggle 1",
					["b_gunitpower"] = true,
					["v_spellname"] = "16511",
					["v_gspellcost"] = "30",
					["v_keybind"] = "<keybind>",
					["v_gunitpower"] = "1",
					["v_gspellcosttype"] = "3",
				},
				["defaultRotation/rogue/kingsbane"] = {
					["v_keybind"] = "<keybind>",
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "192759",
				},
				["defaultRotation/rogue/fan_of_knives"] = {
					["b_gspellcost"] = true,
					["v_durationstartedtime"] = 0,
					["b_gunitpower"] = true,
					["v_spellname"] = "51723",
					["v_gunitpowertype"] = "4",
					["v_gspellcosttype"] = "3",
					["v_gunitpower"] = "1",
					["v_gspellcost"] = "35",
				},
				["defaultRotation/rogue/marked_for_death_anticipation"] = {
					["v_p_unitpower"] = "<6",
					["v_keybind"] = "<keybind>",
					["v_t_needsbuff"] = "_137619",
					["v_p_unitpowertype"] = "4",
					["v_gunitpowertype"] = "4",
					["b_p_unitpower"] = true,
					["b_t_needsbuff"] = true,
					["b_gunitpower"] = true,
					["b_p_knowspell"] = true,
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "137619",
					["v_p_knowspell"] = "114015",
					["v_checkothercdvalue"] = "<1.5",
					["v_gunitpower"] = "5",
					["v_checkothercdname"] = "137619",
				},
				["defaultRotation/rogue/vendetta"] = {
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "79140",
					["v_checkothercdvalue"] = "<1.5",
					["v_keybind"] = "<keybind>",
					["v_checkothercdname"] = "79140",
				},
				["defaultRotation/rogue/deadly_poison"] = {
					["v_p_needbuff"] = "2823",
					["v_p_knownotspell"] = "200802",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "2823",
					["b_p_needbuff"] = true,
					["v_keybind"] = "<keybind>",
					["b_p_knownotspell"] = true,
					["v_togglename"] = "Toggle 1",
				},
				["defaultRotation/rogue/exsanguinate"] = {
					["v_t_hasdebuff"] = "1943^20",
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["b_t_hasdebuff"] = true,
					["v_keybind"] = "<keybind>",
					["v_checkothercdvalue"] = "<1.5",
					["v_spellname"] = "200806",
					["v_checkothercdname"] = "200806",
				},
				["defaultRotation/rogue/marked_for_death_deeper_stratagem"] = {
					["b_gunitpower"] = true,
					["v_p_unitpower"] = "<2",
					["v_t_needsbuff"] = "_137619",
					["v_keybind"] = "<keybind>",
					["v_gunitpowertype"] = "4",
					["v_p_unitpowertype"] = "4",
					["b_t_needsbuff"] = true,
					["b_p_unitpower"] = true,
					["b_p_knowspell"] = true,
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "137619",
					["v_p_knowspell"] = "193531",
					["v_checkothercdvalue"] = "<1.5",
					["v_gunitpower"] = "5",
					["v_checkothercdname"] = "137619",
				},
				["defaultRotation/rogue/death_from_above_deeper_stratagem"] = {
					["b_gspellcost"] = true,
					["v_durationstartedtime"] = 0,
					["v_p_knowspell"] = "193531",
					["b_p_unitpower"] = true,
					["v_keybind"] = "<keybind>",
					["v_gspellcost"] = "25",
					["b_p_knowspell"] = true,
					["v_togglename"] = "Toggle 1",
					["v_p_unitpowertype"] = "4",
					["v_spellname"] = "152150",
					["v_gspellcosttype"] = "3",
					["v_checkothercdvalue"] = "<1.5",
					["v_p_unitpower"] = ">=5",
					["v_checkothercdname"] = "152150",
				},
				["defaultRotation/rogue/rupture"] = {
					["b_gspellcost"] = true,
					["v_gspellcost"] = "25",
					["v_p_knownotspell"] = "193531",
					["b_p_knownotspell"] = true,
					["v_gspellcosttype"] = "3",
					["v_t_needsdebuff"] = "_1943^7.2",
					["v_p_unitpowertype"] = "4",
					["v_togglename"] = "Toggle 1",
					["b_p_unitpower"] = true,
					["v_spellname"] = "1943",
					["b_t_needsdebuff"] = true,
					["v_keybind"] = "<keybind>",
					["v_p_unitpower"] = ">=4",
					["v_durationstartedtime"] = 0,
				},
				["defaultRotation/rogue/agonizing_poison"] = {
					["v_p_needbuff"] = "200802",
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "200802",
					["b_p_needbuff"] = true,
					["v_keybind"] = "<keybind>",
				},
			},
			["specID"] = 1,
			["isMultiTarget"] = true,
		},
		["defaultRotation/rogue/subtlety_multi"] = {
			["version"] = 7,
			["bindindex"] = 0,
			["ActionList"] = {
				["defaultRotation/rogue/death_from_above"] = {
					["b_gspellcost"] = true,
					["v_keybind"] = "<keybind>",
					["v_durationstartedtime"] = 0,
					["v_checkothercdvalue"] = "<1.5",
					["v_gspellcosttype"] = "3",
					["v_togglename"] = "Toggle 1",
					["b_p_unitpower"] = true,
					["v_p_knownotspell"] = "193531",
					["v_p_unitpowertype"] = "4",
					["v_spellname"] = "152150",
					["v_gspellcost"] = "25",
					["b_p_knownotspell"] = true,
					["v_p_unitpower"] = ">=5",
					["v_checkothercdname"] = "152150",
				},
				["defaultRotation/rogue/nightblade_deeper_stratagem"] = {
					["v_t_needsdebuff"] = "_195452^5.4",
					["b_gspellcost"] = true,
					["v_p_knowspell"] = "193531",
					["v_p_unitpowertype"] = "4",
					["v_durationstartedtime"] = 0,
					["b_t_needsdebuff"] = true,
					["b_p_knowspell"] = true,
					["v_togglename"] = "Toggle 1",
					["b_p_unitpower"] = true,
					["v_spellname"] = "195452",
					["v_gspellcosttype"] = "3",
					["v_keybind"] = "<keybind>",
					["v_p_unitpower"] = "=6",
					["v_gspellcost"] = "25",
				},
				["defaultRotation/rogue/shadowstrikes_premeditation"] = {
					["b_gspellcost"] = true,
					["v_gspellcosttype"] = "3",
					["v_gunitpowertype"] = "4",
					["b_p_havebuff"] = true,
					["v_p_havebuff"] = "1784",
					["v_durationstartedtime"] = 0,
					["b_p_knowspell"] = true,
					["v_togglename"] = "Toggle 1",
					["b_gunitpower"] = true,
					["v_spellname"] = "185438",
					["v_gspellcost"] = "40",
					["v_keybind"] = "<keybind>",
					["v_gunitpower"] = "2",
					["v_p_knowspell"] = "196979",
				},
				["defaultRotation/rogue/shuriken_storm"] = {
					["b_gspellcost"] = true,
					["b_gunitpower"] = true,
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "197835",
					["v_gunitpowertype"] = "4",
					["v_gspellcosttype"] = "3",
					["v_gunitpower"] = "2",
					["v_gspellcost"] = "35",
				},
				["defaultRotation/rogue/nightblade"] = {
					["b_gspellcost"] = true,
					["v_p_unitpowertype"] = "4",
					["v_togglename"] = "Toggle 1",
					["b_p_knownotspell"] = true,
					["b_t_needsdebuff"] = true,
					["v_t_needsdebuff"] = "_195452^4.8",
					["v_durationstartedtime"] = 0,
					["v_p_knownotspell"] = "193531",
					["b_p_unitpower"] = true,
					["v_spellname"] = "195452",
					["v_gspellcost"] = "25",
					["v_keybind"] = "<keybind>",
					["v_p_unitpower"] = ">=5",
					["v_gspellcosttype"] = "3",
				},
				["defaultRotation/rogue/goremaw_s_bite"] = {
					["v_p_unitpower2type"] = "4",
					["v_gunitpowertype"] = "4",
					["v_p_unitpower2"] = "<=2",
					["v_durationstartedtime"] = 0,
					["v_gunitpower"] = "3",
					["v_togglename"] = "Toggle 1",
					["b_p_unitpower2"] = true,
					["v_spellname"] = "209782",
					["v_p_unitpowertype"] = "3",
					["v_keybind"] = "<keybind>",
					["v_p_unitpower"] = "<60%",
					["b_gunitpower"] = true,
				},
				["defaultRotation/rogue/shadow_dance"] = {
					["v_p_needbuff"] = "185422||115191",
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_charges"] = ">=2",
					["b_p_needbuff"] = true,
					["v_keybind"] = "<keybind>",
					["v_spellname"] = "185313",
					["b_charges"] = true,
				},
				["defaultRotation/rogue/enveloping_shadows"] = {
					["v_p_needbuff"] = "206237^9",
					["b_gspellcost"] = true,
					["b_p_needbuff"] = true,
					["v_p_knownotspell"] = "193531",
					["v_keybind"] = "<keybind>",
					["v_gspellcosttype"] = "3",
					["b_p_unitpower"] = true,
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "206237",
					["v_gspellcost"] = "30",
					["b_p_knownotspell"] = true,
					["v_p_unitpower"] = ">=5",
					["v_p_unitpowertype"] = "4",
				},
				["defaultRotation/rogue/eviscerate"] = {
					["b_gspellcost"] = true,
					["v_p_unitpowertype"] = "4",
					["v_togglename"] = "Toggle 1",
					["b_p_knownotspell"] = true,
					["v_gspellcosttype"] = "3",
					["v_p_knownotspell"] = "193531",
					["b_p_unitpower"] = true,
					["v_spellname"] = "196819",
					["v_gspellcost"] = "35",
					["v_keybind"] = "<keybind>",
					["v_p_unitpower"] = ">=5",
					["v_durationstartedtime"] = 0,
				},
				["defaultRotation/rogue/eviscerate_deeper_stratagem"] = {
					["b_gspellcost"] = true,
					["v_p_knowspell"] = "193531",
					["v_p_unitpowertype"] = "4",
					["v_gspellcosttype"] = "3",
					["b_p_knowspell"] = true,
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "196819",
					["v_gspellcost"] = "35",
					["v_keybind"] = "<keybind>",
					["v_p_unitpower"] = "=6",
					["b_p_unitpower"] = true,
				},
				["defaultRotation/rogue/shadow_dance_symbols_of_death"] = {
					["v_p_needbuff"] = "212283^10.5||185422||115191",
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "185313",
					["b_p_needbuff"] = true,
					["v_keybind"] = "<keybind>",
					["v_charges"] = ">0",
					["b_charges"] = true,
				},
				["defaultRotation/rogue/crimson_vial"] = {
					["v_p_hp"] = "<60%",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "185311",
					["v_keybind"] = "<keybind>",
					["b_p_hp"] = true,
					["v_togglename"] = "Toggle 1",
				},
				["defaultRotation/rogue/shadowstrikes"] = {
					["b_gspellcost"] = true,
					["v_gunitpower"] = "1",
					["v_gunitpowertype"] = "4",
					["v_keybind"] = "<keybind>",
					["v_gspellcosttype"] = "3",
					["b_p_havebuff"] = true,
					["b_gunitpower"] = true,
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "185438",
					["v_gspellcost"] = "40",
					["b_p_knownotspell"] = true,
					["v_p_havebuff"] = "1784",
					["v_p_knownotspell"] = "196979",
				},
				["defaultRotation/rogue/marked_for_death_anticipation"] = {
					["v_t_needsbuff"] = "_137619",
					["v_p_unitpowertype"] = "4",
					["v_gunitpowertype"] = "4",
					["v_p_unitpower"] = "<5",
					["b_t_needsbuff"] = true,
					["b_gunitpower"] = true,
					["b_p_knowspell"] = true,
					["v_togglename"] = "Toggle 1",
					["b_p_unitpower"] = true,
					["v_spellname"] = "137619",
					["v_durationstartedtime"] = 0,
					["v_keybind"] = "<keybind>",
					["v_gunitpower"] = "5",
					["v_p_knowspell"] = "114015",
				},
				["defaultRotation/rogue/marked_for_death"] = {
					["v_checkothercdvalue"] = "<1.5",
					["v_p_unitpower"] = "<1",
					["v_t_needsbuff"] = "_137619",
					["b_p_knownotspell"] = true,
					["v_gunitpowertype"] = "4",
					["b_gunitpower"] = true,
					["b_t_needsbuff"] = true,
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_p_knownotspell"] = "193531||114015",
					["b_p_unitpower"] = true,
					["v_spellname"] = "137619",
					["v_p_unitpowertype"] = "4",
					["v_keybind"] = "<keybind>",
					["v_gunitpower"] = "5",
					["v_checkothercdname"] = "137619",
				},
				["defaultRotation/rogue/symbols_of_death"] = {
					["v_p_needbuff"] = "212283^10.5",
					["b_p_needbuff"] = true,
					["b_p_havebuff"] = true,
					["b_gspellcost"] = true,
					["v_keybind"] = "<keybind>",
					["v_gspellcost"] = "35",
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "212283",
					["v_gspellcosttype"] = "3",
					["v_checkothercdvalue"] = "<1.5",
					["v_p_havebuff"] = "1784||185422||115192",
					["v_checkothercdname"] = "212283",
				},
				["defaultRotation/rogue/shadow_blades"] = {
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "121471",
					["v_keybind"] = "<keybind>",
					["v_checkothercdvalue"] = "<1.5",
					["b_isCustomCase1"] = true,
					["v_checkothercdname"] = "121471",
				},
				["defaultRotation/rogue/kick"] = {
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "1766",
					["v_keybind"] = "<keybind>",
					["v_checkothercdvalue"] = "<1.5",
					["b_t_interrupt"] = true,
					["v_checkothercdname"] = "1766",
				},
				["defaultRotation/rogue/death_from_above_deeper_stratagem"] = {
					["b_gspellcost"] = true,
					["v_durationstartedtime"] = 0,
					["v_p_knowspell"] = "193531",
					["v_p_unitpowertype"] = "4",
					["v_keybind"] = "<keybind>",
					["v_gspellcosttype"] = "3",
					["b_p_knowspell"] = true,
					["v_togglename"] = "Toggle 1",
					["b_p_unitpower"] = true,
					["v_spellname"] = "152150",
					["v_gspellcost"] = "25",
					["v_checkothercdvalue"] = "<1.5",
					["v_p_unitpower"] = "=6",
					["v_checkothercdname"] = "152150",
				},
				["defaultRotation/rogue/enveloping_shadows_deeper_stratagem"] = {
					["v_p_needbuff"] = "206237^10.8",
					["b_p_unitpower"] = true,
					["v_p_knowspell"] = "193531",
					["v_gspellcost"] = "30",
					["b_gspellcost"] = true,
					["v_durationstartedtime"] = 0,
					["b_p_knowspell"] = true,
					["v_togglename"] = "Toggle 1",
					["v_p_unitpowertype"] = "4",
					["v_spellname"] = "206237",
					["v_gspellcosttype"] = "3",
					["v_keybind"] = "<keybind>",
					["v_p_unitpower"] = "=6",
					["b_p_needbuff"] = true,
				},
				["defaultRotation/rogue/marked_for_death_deeper_stratagem"] = {
					["v_t_needsbuff"] = "_137619",
					["b_gunitpower"] = true,
					["v_p_knowspell"] = "193531",
					["v_p_unitpower"] = "<1",
					["b_t_needsbuff"] = true,
					["b_p_unitpower"] = true,
					["b_p_knowspell"] = true,
					["v_togglename"] = "Toggle 1",
					["v_durationstartedtime"] = 0,
					["v_spellname"] = "137619",
					["v_p_unitpowertype"] = "4",
					["v_keybind"] = "<keybind>",
					["v_gunitpower"] = "5",
					["v_gunitpowertype"] = "4",
				},
			},
			["specID"] = 3,
			["SortedActions"] = {
				"defaultRotation/rogue/kick", -- [1]
				"defaultRotation/rogue/crimson_vial", -- [2]
				"defaultRotation/rogue/marked_for_death_anticipation", -- [3]
				"defaultRotation/rogue/marked_for_death_deeper_stratagem", -- [4]
				"defaultRotation/rogue/marked_for_death", -- [5]
				"defaultRotation/rogue/symbols_of_death", -- [6]
				"defaultRotation/rogue/death_from_above_deeper_stratagem", -- [7]
				"defaultRotation/rogue/death_from_above", -- [8]
				"defaultRotation/rogue/nightblade_deeper_stratagem", -- [9]
				"defaultRotation/rogue/nightblade", -- [10]
				"defaultRotation/rogue/enveloping_shadows_deeper_stratagem", -- [11]
				"defaultRotation/rogue/enveloping_shadows", -- [12]
				"defaultRotation/rogue/eviscerate_deeper_stratagem", -- [13]
				"defaultRotation/rogue/eviscerate", -- [14]
				"defaultRotation/rogue/shadowstrikes_premeditation", -- [15]
				"defaultRotation/rogue/shadowstrikes", -- [16]
				"defaultRotation/rogue/shadow_dance_symbols_of_death", -- [17]
				"defaultRotation/rogue/shadow_dance", -- [18]
				"defaultRotation/rogue/goremaw_s_bite", -- [19]
				"defaultRotation/rogue/shadow_blades", -- [20]
				"defaultRotation/rogue/shuriken_storm", -- [21]
			},
			["isMultiTarget"] = true,
		}
	}
	return rotation;
end

local rogueRotationsGeneratorData = {
	["generator"] = rogueRotationsGenerator
};

RotationBuilder:addDefaultRotationsGenerator("ROGUE", rogueRotationsGeneratorData);
